﻿///////////////////////////////////////////////////////////////
// This is generated code. 
//////////////////////////////////////////////////////////////
// Code is generated using LLBLGen Pro version: 2.6
// Code is generated on: Tuesday, 28 April 2009 3:48:36 PM
// Code is generated using templates: SD.TemplateBindings.SharedTemplates.NET20
// Templates vendor: Solutions Design.
// Templates version: 
//////////////////////////////////////////////////////////////
using System.Collections.Generic;
using SD.LLBLGen.Pro.ORMSupportClasses;
using WorkflowService.Model.HelperClasses;

namespace WorkflowService.Model.RelationClasses
{
	/// <summary>Implements the static Relations variant for the entity: State. </summary>
	public partial class StateRelations
	{
		/// <summary>CTor</summary>
		public StateRelations()
		{
		}

		/// <summary>Gets all relations of the StateEntity as a list of IEntityRelation objects.</summary>
		/// <returns>a list of IEntityRelation objects</returns>
		public virtual List<IEntityRelation> GetAllRelations()
		{
			List<IEntityRelation> toReturn = new List<IEntityRelation>();
			toReturn.Add(this.CanTransitionToEntityUsingToStateId);
			toReturn.Add(this.CanTransitionToEntityUsingFromStateId);
			toReturn.Add(this.StateMachineInstanceEntityUsingCurrentState);

			toReturn.Add(this.StateMachineEntityUsingStateMachineId);
			return toReturn;
		}

		#region Class Property Declarations

		/// <summary>Returns a new IEntityRelation object, between StateEntity and CanTransitionToEntity over the 1:n relation they have, using the relation between the fields:
		/// State.Id - CanTransitionTo.ToStateId
		/// </summary>
		public virtual IEntityRelation CanTransitionToEntityUsingToStateId
		{
			get
			{
				IEntityRelation relation = new EntityRelation(SD.LLBLGen.Pro.ORMSupportClasses.RelationType.OneToMany, "CanTransitionTo_" , true);
				relation.AddEntityFieldPair(StateFields.Id, CanTransitionToFields.ToStateId);
				relation.InheritanceInfoPkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("StateEntity", true);
				relation.InheritanceInfoFkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("CanTransitionToEntity", false);
				return relation;
			}
		}

		/// <summary>Returns a new IEntityRelation object, between StateEntity and CanTransitionToEntity over the 1:n relation they have, using the relation between the fields:
		/// State.Id - CanTransitionTo.FromStateId
		/// </summary>
		public virtual IEntityRelation CanTransitionToEntityUsingFromStateId
		{
			get
			{
				IEntityRelation relation = new EntityRelation(SD.LLBLGen.Pro.ORMSupportClasses.RelationType.OneToMany, "CanTransitionTo" , true);
				relation.AddEntityFieldPair(StateFields.Id, CanTransitionToFields.FromStateId);
				relation.InheritanceInfoPkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("StateEntity", true);
				relation.InheritanceInfoFkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("CanTransitionToEntity", false);
				return relation;
			}
		}

		/// <summary>Returns a new IEntityRelation object, between StateEntity and StateMachineInstanceEntity over the 1:n relation they have, using the relation between the fields:
		/// State.Id - StateMachineInstance.CurrentState
		/// </summary>
		public virtual IEntityRelation StateMachineInstanceEntityUsingCurrentState
		{
			get
			{
				IEntityRelation relation = new EntityRelation(SD.LLBLGen.Pro.ORMSupportClasses.RelationType.OneToMany, "StateMachineInstance" , true);
				relation.AddEntityFieldPair(StateFields.Id, StateMachineInstanceFields.CurrentState);
				relation.InheritanceInfoPkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("StateEntity", true);
				relation.InheritanceInfoFkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("StateMachineInstanceEntity", false);
				return relation;
			}
		}


		/// <summary>Returns a new IEntityRelation object, between StateEntity and StateMachineEntity over the m:1 relation they have, using the relation between the fields:
		/// State.StateMachineId - StateMachine.Id
		/// </summary>
		public virtual IEntityRelation StateMachineEntityUsingStateMachineId
		{
			get
			{
				IEntityRelation relation = new EntityRelation(SD.LLBLGen.Pro.ORMSupportClasses.RelationType.ManyToOne, "StateMachine", false);
				relation.AddEntityFieldPair(StateMachineFields.Id, StateFields.StateMachineId);
				relation.InheritanceInfoPkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("StateMachineEntity", false);
				relation.InheritanceInfoFkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("StateEntity", true);
				return relation;
			}
		}

		/// <summary>stub, not used in this entity, only for TargetPerEntity entities.</summary>
		public virtual IEntityRelation GetSubTypeRelation(string subTypeEntityName) { return null; }
		/// <summary>stub, not used in this entity, only for TargetPerEntity entities.</summary>
		public virtual IEntityRelation GetSuperTypeRelation() { return null;}

		#endregion

		#region Included Code

		#endregion
	}
}
