﻿///////////////////////////////////////////////////////////////
// This is generated code. 
//////////////////////////////////////////////////////////////
// Code is generated using LLBLGen Pro version: 2.6
// Code is generated on: Tuesday, 28 April 2009 3:48:36 PM
// Code is generated using templates: SD.TemplateBindings.SharedTemplates.NET20
// Templates vendor: Solutions Design.
// Templates version: 
//////////////////////////////////////////////////////////////
using SD.LLBLGen.Pro.ORMSupportClasses;

namespace WorkflowService.Model.HelperClasses
{
	
	// __LLBLGENPRO_USER_CODE_REGION_START AdditionalNamespaces
	// __LLBLGENPRO_USER_CODE_REGION_END
	
	/// <summary>
	/// Singleton implementation of the FieldInfoProvider. This class is the singleton wrapper through which the actual instance is retrieved.
	/// </summary>
	/// <remarks>It uses a single instance of an internal class. The access isn't marked with locks as the FieldInfoProviderBase class is threadsafe.</remarks>
	internal sealed class FieldInfoProviderSingleton
	{
		#region Class Member Declarations
		private static readonly IFieldInfoProvider _providerInstance = new FieldInfoProviderCore();
		#endregion
		
		/// <summary>private ctor to prevent instances of this class.</summary>
		private FieldInfoProviderSingleton()
		{
		}

		/// <summary>Dummy static constructor to make sure threadsafe initialization is performed.</summary>
		static FieldInfoProviderSingleton()
		{
		}

		/// <summary>Gets the singleton instance of the FieldInfoProviderCore</summary>
		/// <returns>Instance of the FieldInfoProvider.</returns>
		public static IFieldInfoProvider GetInstance()
		{
			return _providerInstance;
		}
	}

	/// <summary>Actual implementation of the FieldInfoProvider. Used by singleton wrapper.</summary>
	internal class FieldInfoProviderCore : FieldInfoProviderBase
	{
		/// <summary>Initializes a new instance of the <see cref="FieldInfoProviderCore"/> class.</summary>
		internal FieldInfoProviderCore()
		{
			Init();
		}

		/// <summary>Method which initializes the internal datastores.</summary>
		private void Init()
		{
			base.InitClass( (8 + 0));
			InitCanTransitionToEntityInfos();
			InitMustHaveRoleEntityInfos();
			InitRoleEntityInfos();
			InitStateEntityInfos();
			InitStateMachineEntityInfos();
			InitStateMachineInstanceEntityInfos();
			InitWorkflowEntityInfos();
			InitWorkflowInstanceEntityInfos();

			base.ConstructElementFieldStructures(InheritanceInfoProviderSingleton.GetInstance());
		}

		/// <summary>Inits CanTransitionToEntity's FieldInfo objects</summary>
		private void InitCanTransitionToEntityInfos()
		{
			base.AddElementFieldInfo("CanTransitionToEntity", "Id", typeof(System.Int32), true, false, true, false,  (int)CanTransitionToFieldIndex.Id, 0, 0, 10);
			base.AddElementFieldInfo("CanTransitionToEntity", "FromStateId", typeof(System.Int32), false, true, false, false,  (int)CanTransitionToFieldIndex.FromStateId, 0, 0, 10);
			base.AddElementFieldInfo("CanTransitionToEntity", "ToStateId", typeof(System.Int32), false, true, false, false,  (int)CanTransitionToFieldIndex.ToStateId, 0, 0, 10);
		}
		/// <summary>Inits MustHaveRoleEntity's FieldInfo objects</summary>
		private void InitMustHaveRoleEntityInfos()
		{
			base.AddElementFieldInfo("MustHaveRoleEntity", "CanTransitionToId", typeof(System.Int32), true, true, false, false,  (int)MustHaveRoleFieldIndex.CanTransitionToId, 0, 0, 10);
			base.AddElementFieldInfo("MustHaveRoleEntity", "RoleId", typeof(System.Int32), true, true, false, false,  (int)MustHaveRoleFieldIndex.RoleId, 0, 0, 10);
		}
		/// <summary>Inits RoleEntity's FieldInfo objects</summary>
		private void InitRoleEntityInfos()
		{
			base.AddElementFieldInfo("RoleEntity", "Id", typeof(System.Int32), true, false, false, false,  (int)RoleFieldIndex.Id, 0, 0, 10);
			base.AddElementFieldInfo("RoleEntity", "Name", typeof(System.String), false, false, false, false,  (int)RoleFieldIndex.Name, 25, 0, 0);
		}
		/// <summary>Inits StateEntity's FieldInfo objects</summary>
		private void InitStateEntityInfos()
		{
			base.AddElementFieldInfo("StateEntity", "Id", typeof(System.Int32), true, false, true, false,  (int)StateFieldIndex.Id, 0, 0, 10);
			base.AddElementFieldInfo("StateEntity", "StateMachineId", typeof(System.Int32), false, true, false, false,  (int)StateFieldIndex.StateMachineId, 0, 0, 10);
			base.AddElementFieldInfo("StateEntity", "Name", typeof(System.String), false, false, false, false,  (int)StateFieldIndex.Name, 25, 0, 0);
			base.AddElementFieldInfo("StateEntity", "IsInitialState", typeof(System.Boolean), false, false, false, false,  (int)StateFieldIndex.IsInitialState, 0, 0, 0);
			base.AddElementFieldInfo("StateEntity", "IsFinalState", typeof(System.Boolean), false, false, false, false,  (int)StateFieldIndex.IsFinalState, 0, 0, 0);
		}
		/// <summary>Inits StateMachineEntity's FieldInfo objects</summary>
		private void InitStateMachineEntityInfos()
		{
			base.AddElementFieldInfo("StateMachineEntity", "Id", typeof(System.Int32), true, false, true, false,  (int)StateMachineFieldIndex.Id, 0, 0, 10);
			base.AddElementFieldInfo("StateMachineEntity", "Name", typeof(System.String), false, false, false, false,  (int)StateMachineFieldIndex.Name, 25, 0, 0);
		}
		/// <summary>Inits StateMachineInstanceEntity's FieldInfo objects</summary>
		private void InitStateMachineInstanceEntityInfos()
		{
			base.AddElementFieldInfo("StateMachineInstanceEntity", "Id", typeof(System.Int32), true, false, true, false,  (int)StateMachineInstanceFieldIndex.Id, 0, 0, 10);
			base.AddElementFieldInfo("StateMachineInstanceEntity", "StateMachineId", typeof(System.Int32), false, true, false, false,  (int)StateMachineInstanceFieldIndex.StateMachineId, 0, 0, 10);
			base.AddElementFieldInfo("StateMachineInstanceEntity", "CurrentState", typeof(System.Int32), false, true, false, false,  (int)StateMachineInstanceFieldIndex.CurrentState, 0, 0, 10);
		}
		/// <summary>Inits WorkflowEntity's FieldInfo objects</summary>
		private void InitWorkflowEntityInfos()
		{
			base.AddElementFieldInfo("WorkflowEntity", "Id", typeof(System.Int32), true, false, false, false,  (int)WorkflowFieldIndex.Id, 0, 0, 10);
			base.AddElementFieldInfo("WorkflowEntity", "Guid", typeof(System.Guid), false, false, false, false,  (int)WorkflowFieldIndex.Guid, 0, 0, 0);
		}
		/// <summary>Inits WorkflowInstanceEntity's FieldInfo objects</summary>
		private void InitWorkflowInstanceEntityInfos()
		{
			base.AddElementFieldInfo("WorkflowInstanceEntity", "Id", typeof(System.Int32), true, false, false, false,  (int)WorkflowInstanceFieldIndex.Id, 0, 0, 10);
			base.AddElementFieldInfo("WorkflowInstanceEntity", "Guid", typeof(System.Guid), false, false, false, false,  (int)WorkflowInstanceFieldIndex.Guid, 0, 0, 0);
		}
		
	}
}




