﻿///////////////////////////////////////////////////////////////
// This is generated code. 
//////////////////////////////////////////////////////////////
// Code is generated using LLBLGen Pro version: 2.6
// Code is generated on: Tuesday, 28 April 2009 3:48:36 PM
// Code is generated using templates: SD.TemplateBindings.SharedTemplates.NET20
// Templates vendor: Solutions Design.
// Templates version: 
//////////////////////////////////////////////////////////////
using System.Collections.Generic;
using SD.LLBLGen.Pro.ORMSupportClasses;
using WorkflowService.Model.HelperClasses;

namespace WorkflowService.Model.RelationClasses
{
	/// <summary>Implements the static Relations variant for the entity: CanTransitionTo. </summary>
	public partial class CanTransitionToRelations
	{
		/// <summary>CTor</summary>
		public CanTransitionToRelations()
		{
		}

		/// <summary>Gets all relations of the CanTransitionToEntity as a list of IEntityRelation objects.</summary>
		/// <returns>a list of IEntityRelation objects</returns>
		public virtual List<IEntityRelation> GetAllRelations()
		{
			List<IEntityRelation> toReturn = new List<IEntityRelation>();
			toReturn.Add(this.MustHaveRoleEntityUsingCanTransitionToId);

			toReturn.Add(this.StateEntityUsingToStateId);
			toReturn.Add(this.StateEntityUsingFromStateId);
			return toReturn;
		}

		#region Class Property Declarations

		/// <summary>Returns a new IEntityRelation object, between CanTransitionToEntity and MustHaveRoleEntity over the 1:n relation they have, using the relation between the fields:
		/// CanTransitionTo.Id - MustHaveRole.CanTransitionToId
		/// </summary>
		public virtual IEntityRelation MustHaveRoleEntityUsingCanTransitionToId
		{
			get
			{
				IEntityRelation relation = new EntityRelation(SD.LLBLGen.Pro.ORMSupportClasses.RelationType.OneToMany, "MustHaveRole" , true);
				relation.AddEntityFieldPair(CanTransitionToFields.Id, MustHaveRoleFields.CanTransitionToId);
				relation.InheritanceInfoPkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("CanTransitionToEntity", true);
				relation.InheritanceInfoFkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("MustHaveRoleEntity", false);
				return relation;
			}
		}


		/// <summary>Returns a new IEntityRelation object, between CanTransitionToEntity and StateEntity over the m:1 relation they have, using the relation between the fields:
		/// CanTransitionTo.ToStateId - State.Id
		/// </summary>
		public virtual IEntityRelation StateEntityUsingToStateId
		{
			get
			{
				IEntityRelation relation = new EntityRelation(SD.LLBLGen.Pro.ORMSupportClasses.RelationType.ManyToOne, "ToState", false);
				relation.AddEntityFieldPair(StateFields.Id, CanTransitionToFields.ToStateId);
				relation.InheritanceInfoPkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("StateEntity", false);
				relation.InheritanceInfoFkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("CanTransitionToEntity", true);
				return relation;
			}
		}
		/// <summary>Returns a new IEntityRelation object, between CanTransitionToEntity and StateEntity over the m:1 relation they have, using the relation between the fields:
		/// CanTransitionTo.FromStateId - State.Id
		/// </summary>
		public virtual IEntityRelation StateEntityUsingFromStateId
		{
			get
			{
				IEntityRelation relation = new EntityRelation(SD.LLBLGen.Pro.ORMSupportClasses.RelationType.ManyToOne, "FromState", false);
				relation.AddEntityFieldPair(StateFields.Id, CanTransitionToFields.FromStateId);
				relation.InheritanceInfoPkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("StateEntity", false);
				relation.InheritanceInfoFkSideEntity = InheritanceInfoProviderSingleton.GetInstance().GetInheritanceInfo("CanTransitionToEntity", true);
				return relation;
			}
		}

		/// <summary>stub, not used in this entity, only for TargetPerEntity entities.</summary>
		public virtual IEntityRelation GetSubTypeRelation(string subTypeEntityName) { return null; }
		/// <summary>stub, not used in this entity, only for TargetPerEntity entities.</summary>
		public virtual IEntityRelation GetSuperTypeRelation() { return null;}

		#endregion

		#region Included Code

		#endregion
	}
}
